//---------------------------------------------------------------------------------------------------
//		ANA_INS_INMS_3.java
//---------------------------------------------------------------------------------------------------


//---------------------------------------------------------------------------------------------------
//		Package Definition
//---------------------------------------------------------------------------------------------------

package sim.test.remote.ana_ins_inms;
	       

//---------------------------------------------------------------------------------------------------
//		Imports
//---------------------------------------------------------------------------------------------------

import javacard.framework.*;

import sim.access.*;
import sim.toolkit.*;



public class ana_ins_inms_3 extends javacard.framework.Applet implements ToolkitInterface,ToolkitConstants{ 
    
    private SIMView theSIMView;
    
    static byte[] data = new byte[3];
   
    public final static short FID_DF_SIMTEST  = (short)0x0319;
    public final static short FID_EF_TNU  = (short)0x6F02;
    public final static short FID_EF_TARU = (short)0x6F03;
    
        /*
    *Constructor of the applet
    *
    */
    public ana_ins_inms_3(){
            
        ToolkitRegistry obReg = ToolkitRegistry.getEntry();    
       //register to EVENT_UNFORMATTED_SMS_PP_ENV
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
	theSIMView = SIMSystem.getTheSIMView();
    }


    /**
    *Method called by the JCRE at the intallation of the applet.
    */
     public static void install(byte[] bArray, short bOffset, byte bLength) {

         ana_ins_inms_3 testApplet = new ana_ins_inms_3();
         // Register the applet with the JCRE.
         testApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
    }


    /**
    *Method called by the SIM Toolkit Framework
    *
    */
    public void processToolkit(byte event) throws ToolkitException 
    {    	
    	short fileOffset = 0;
        short dataOffset = 0;
        short dataLength = 0;

	short TPUDLOffset = 0;

	//copy the data in EVENT_UNFORMATTED_SMS_PP_ENV to identify the test case
	EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
	TPUDLOffset = envHdlr.getTPUDLOffset();
    	envHdlr.copyValue((short)(TPUDLOffset+1),(byte[]) data, (short) 0, (short) 3);
    	
    	if(event == EVENT_UNFORMATTED_SMS_PP_ENV)
    	{
    		
    		switch(data[0])
    		{
    		
    			case 1:
    			case 2:
		    		try {
		    	 		fileOffset = 0;
			                dataOffset = 0;
			                dataLength = 3;
			                
		                	theSIMView.select(FID_DF_SIMTEST);
			                theSIMView.select(FID_EF_TARU);
			                theSIMView.updateBinary(fileOffset, data, dataOffset, dataLength);               
		
		        	}catch (SIMViewException sve) {
		
		            	}
    				break;
    			case 3:
    				try {
		    	 		fileOffset = 0;
			                dataOffset = 0;
			                dataLength = 3;
		                
		                	theSIMView.select(FID_DF_SIMTEST);
			                theSIMView.select(FID_EF_TNU);
			                theSIMView.updateBinary(fileOffset, data, dataOffset, dataLength);               
		
		        	}catch (SIMViewException sve) {
		
		            	}
    				break;    		
    		
    		}
    	
    	}
    	
    	
    	
    }
    
     public void process (javacard.framework.APDU apdu) 
    {
    }   
    
    
}
